--This file fixes some of the problems with music mods, including the bug that makes bosses and other music play at the same time as the samples, 
--and it also adds some custom sfx. (by 6b)

local SAMPLE_STAR_SELECT_SIMS = audio_sample_load('star_select_sims.ogg')
local SAMPLE_LOSE = audio_sample_load('lose.ogg')

function nomusic()
	for i=0,38,1 do
		stop_background_music(SEQ_LEVEL_INSIDE_CASTLE)
		stop_background_music(SEQ_LEVEL_GRASS)
		stop_background_music(SEQ_EVENT_BOSS)
		stop_background_music(SEQ_EVENT_POWERUP)
		stop_background_music(SEQ_EVENT_METAL_CAP)
		stop_background_music(SEQ_EVENT_RACE)
		stop_background_music(SEQ_LEVEL_SLIDE)
		stop_background_music(SEQ_LEVEL_SNOW)
		stop_background_music(SEQ_LEVEL_KOOPA_ROAD)
		stop_background_music(SEQ_LEVEL_BOSS_KOOPA_FINAL)
		stop_background_music(SEQ_LEVEL_HOT)
		stop_background_music(SEQ_LEVEL_SPOOKY)
		stop_background_music(SEQ_LEVEL_WATER)
		stop_background_music(SEQ_LEVEL_BOSS_KOOPA)
		stop_background_music(SEQ_LEVEL_UNDERGROUND)
		stop_background_music(SEQ_LEVEL_BOSS_KOOPA_FINAL)
    end
end

function musicremplace()
	if get_current_background_music() == SEQ_MENU_STAR_SELECT then
		stop_background_music(SEQ_MENU_STAR_SELECT)
		audio_sample_play(SAMPLE_STAR_SELECT_SIMS, gMarioStates[0].marioObj.header.gfx.cameraToObject, 2)
    end
end


	local deathTable = {
		[ACT_DEATH_ON_STOMACH] = true,
		[ACT_DEATH_ON_BACK] = true,
		[ACT_EATEN_BY_BUBBA] = true,
		[ACT_SUFFOCATION] = true,
		[ACT_STANDING_DEATH] = true,
		[ACT_QUICKSAND_DEATH] = true,
		[ACT_DROWNING] = true,
	}

	
	function on_set_mario_action(m)
		if deathTable[m.action] then
				audio_sample_play(SAMPLE_LOSE, {x = 0, y = 0, z = 0}, 2)
		end
	end


hook_event(HOOK_UPDATE, nomusic)
hook_event(HOOK_UPDATE, musicremplace)
hook_event(HOOK_ON_SET_MARIO_ACTION, on_set_mario_action)
